﻿#region LicenseHeader

// Copyright 2012 The Trustees of Indiana University.  All rights reserved.
// 
// The Indiana University licenses this file to you under the Apache License, 
// Version 2.0 (the "License"); you may not use this file except in compliance 
// with the License.  You may obtain a copy of the License at 
// 
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software 
// distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
//  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  
// See the License for the specific language governing permissions and 
// limitations under the License.
// 
// @author Thilina Gunarathne (tgunarat@indiana.edu)

#endregion

#region

using System;
using Microsoft.WindowsAzure.StorageClient;

#endregion

namespace AzureMRCore.DataModel
{
    public class JobDataModel : TableServiceEntity
    {
        public JobDataModel()
        {
            PartitionKey = "AzureMRJobs";
        }

        public JobDataModel(string jobID, int numReduceTasks, string programParams, string outDir, string inDir)
        {
            PartitionKey = "AzureMRJobs";
            RowKey = jobID;
            NumReduceTasks = numReduceTasks;
            ProgramParams = programParams;
            OutDir = outDir;
            InDir = inDir;
            StartTime = string.Format("{0:G}", DateTime.Now);
            //RowKey = string.Format("{0:10}_{1}", DateTime.MaxValue.Ticks - DateTime.Now.Ticks, Guid.NewGuid());            
        }

        public int NumMapTasks { get; set; }
        public int NumReduceTasks { get; set; }
        public int CurrentIteration { get; set; }
        public int NumIterations { get; set; }

        public string ProgramParams { get; set; }
        public int Status { get; set; }
        public string OutDir { get; set; }
        public string InDir { get; set; }
        public bool PerformMerge { get; set; }

        public string CleanupTime { get; set; }
        public string StartTime { get; set; }
    }
}