﻿#region LicenseHeader

// Copyright 2012 The Trustees of Indiana University.  All rights reserved.
// 
// The Indiana University licenses this file to you under the Apache License, 
// Version 2.0 (the "License"); you may not use this file except in compliance 
// with the License.  You may obtain a copy of the License at 
// 
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software 
// distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
//  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  
// See the License for the specific language governing permissions and 
// limitations under the License.
// 
// @author Thilina Gunarathne (tgunarat@indiana.edu)

#endregion

#region

using System;
using System.Collections.Generic;

#endregion

namespace AzureMRCore.DataTypes
{
    /**
     * Stores a list of lists. Usefull in storing sparse matrices. 
     * (Eg: to store the adjucency matrixc
     */

    public class AdjacencyListValue<TYPE> : IValue
    {
        public Dictionary<int, List<TYPE>> AdjList { get; set; }

        #region IValue Members

        public string GetTextValue()
        {
            throw new NotImplementedException();
        }

        public bool ParseValue(object value)
        {
            if (value is Dictionary<int, List<TYPE>>)
            {
                AdjList = (Dictionary<int, List<TYPE>>) value;
                return true;
            }
            return false;
        }

        public byte[] GetBytes()
        {
            throw new NotImplementedException();
        }

        public bool FromBytes(byte[] value)
        {
            throw new NotImplementedException();
        }

        public long Size()
        {
            //disabling
            return 100*1024;
        }

        #endregion

        public static AdjacencyListValue<TYPE> GetInstance(Dictionary<int, List<TYPE>> matrix, int vectorLength)
        {
            var instance = new AdjacencyListValue<TYPE> {AdjList = matrix};
            return instance;
        }
    }
}