﻿#region LicenseHeader

// Copyright 2012 The Trustees of Indiana University.  All rights reserved.
// 
// The Indiana University licenses this file to you under the Apache License, 
// Version 2.0 (the "License"); you may not use this file except in compliance 
// with the License.  You may obtain a copy of the License at 
// 
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software 
// distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
//  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  
// See the License for the specific language governing permissions and 
// limitations under the License.
// 
// @author Thilina Gunarathne (tgunarat@indiana.edu)

#endregion

#region

using System;
using System.IO;

#endregion

namespace AzureMRCore.DataTypes
{
    public class FileValue : IValue
    {
        public FileInfo Value { get; set; }

        #region IValue Members

        public string GetTextValue()
        {
            return Value.FullName;
        }


        public Boolean ParseValue(object value)
        {
            if (value is string)
            {
                Value = new FileInfo((string) value);
                return true;
            }
            if (value is FileInfo)
            {
                Value = (FileInfo) value;
                return true;
            }
            return false;
        }

        public byte[] GetBytes()
        {
            throw new NotImplementedException();
        }

        public bool FromBytes(byte[] value)
        {
            throw new NotImplementedException();
        }

        public long Size()
        {
            //disabling table intermediate data for fileValues
//            if (Value.Length < (63*1024))
//            {
//                return 100*1024;
//            }
//            return Value.Length;
            return long.MaxValue;
        }

        #endregion

        public static FileValue GetInstance(FileInfo value)
        {
            FileValue instance = new FileValue {Value = value};
            return instance;
        }
    }
}