﻿#region LicenseHeader

// Copyright 2012 The Trustees of Indiana University.  All rights reserved.
// 
// The Indiana University licenses this file to you under the Apache License, 
// Version 2.0 (the "License"); you may not use this file except in compliance 
// with the License.  You may obtain a copy of the License at 
// 
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software 
// distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
//  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  
// See the License for the specific language governing permissions and 
// limitations under the License.
// 
// @author Thilina Gunarathne (tgunarat@indiana.edu)

#endregion

#region

using System;

#endregion

namespace AzureMRCore.DataTypes
{
    public class IntKey : Key
    {
        public int Key { get; set; }

        public override uint GetHashValue()
        {
            return (uint) Key;
        }


        public override Boolean Parse(object key)
        {
            if (key is string)
            {
                int value;
                Boolean success = Int32.TryParse((string) key, out value);
                Key = value;
                return success;
            }
            return false;
        }

        public override string GetTextValue()
        {
            return Key.ToString();
        }

        public static IntKey GetInstance(int key)
        {
            IntKey instance = new IntKey {Key = key};
            return instance;
        }
    }
}