﻿#region LicenseHeader

// Copyright 2012 The Trustees of Indiana University.  All rights reserved.
// 
// The Indiana University licenses this file to you under the Apache License, 
// Version 2.0 (the "License"); you may not use this file except in compliance 
// with the License.  You may obtain a copy of the License at 
// 
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software 
// distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
//  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  
// See the License for the specific language governing permissions and 
// limitations under the License.
// 
// @author Thilina Gunarathne (tgunarat@indiana.edu)

#endregion

using System;
using System.Runtime.CompilerServices;
using AzureMRCore.InputFormat;

namespace AzureMRCore.IterativeDataCache
{
    public class CachedItem
    {
        public CachedItem(ICachedInputFormat inputFormat, string blobURL, string jobID, int iteration, string appName,
                          long size)
        {
            CachedInputFormat = inputFormat;
            BlobURL = blobURL;
            JobID = jobID;
            Size = size;
            Iteration = iteration;
            AppName = appName;
        }

        public string BlobURL { get; set; }
        public string JobID { get; set; }
        public string MapID { get; set; }
        public DateTime AddedTime { get; set; }
        public DateTime LastupdatedTime { get; set; }
        public long Size { get; set; }
        public Boolean IsBCastData { get; set; }
        public string AppName { get; set; }

        public CachedItem(ICachedInputFormat inputFormat, string blobURL, string jobID, int iteration, long size,
                          Boolean isBCastData)
        {
            CachedInputFormat = inputFormat;
            BlobURL = blobURL;
            JobID = jobID;
            Size = size;
            Iteration = iteration;
            IsBCastData = isBCastData;
        }

        public int Iteration { [MethodImpl(MethodImplOptions.Synchronized)]
        get; [MethodImpl(MethodImplOptions.Synchronized)]
        set; }

        public ICachedInputFormat CachedInputFormat { get; set; }
    }
}