﻿#region LicenseHeader

// Copyright 2012 The Trustees of Indiana University.  All rights reserved.
// 
// The Indiana University licenses this file to you under the Apache License, 
// Version 2.0 (the "License"); you may not use this file except in compliance 
// with the License.  You may obtain a copy of the License at 
// 
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software 
// distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
//  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  
// See the License for the specific language governing permissions and 
// limitations under the License.
// 
// @author Thilina Gunarathne (tgunarat@indiana.edu)

#endregion

using AzureMRCore.Drivers;
using AzureMRCore.InputFormat;
using AzureMRCore.IterativeDataCache;
using Microsoft.WindowsAzure;

namespace AzureMRCore.MapRed
{
    public interface IMapper
    {
        bool Init(CloudStorageAccount storageAccount, MRConf mrConf, MRDriver mrDriver, DataCache dataCache,
                  object configOut);

        bool ExecuteMapTask(ICachedInputFormat inputFormat, MapTaskContext mapTaskContext);
        bool ExecuteMapTask(MapTaskContext mapTaskContext);
    }
}