﻿#region LicenseHeader

// Copyright 2012 The Trustees of Indiana University.  All rights reserved.
// 
// The Indiana University licenses this file to you under the Apache License, 
// Version 2.0 (the "License"); you may not use this file except in compliance 
// with the License.  You may obtain a copy of the License at 
// 
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software 
// distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
//  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  
// See the License for the specific language governing permissions and 
// limitations under the License.
// 
// @author Thilina Gunarathne (tgunarat@indiana.edu)

#endregion

#region

using AzureMRCore.DataTypes;
using AzureMRCore.Drivers;
using AzureMRCore.InputFormat;
using AzureMRCore.MapRed;

#endregion

namespace Cap3Sample
{
    public class Cap3MRWorker : MapOnlyDriver<StringKey, StringValue, StringKey, StringValue>
    {
        public override string Name
        {
            get { return "Cap3MR"; }
        }

        public override Mapper<StringKey, StringValue, StringKey, StringValue, NullKey, NullValue> MapperType
        {
            get { return new Cap3Mapper(); }
        }

        public override IInputFormat<StringKey, StringValue> InputFormatType
        {
            get { return new FileInputFormat(); }
        }
    }
}