﻿#region LicenseHeader

// Copyright 2012 The Trustees of Indiana University.  All rights reserved.
// 
// The Indiana University licenses this file to you under the Apache License, 
// Version 2.0 (the "License"); you may not use this file except in compliance 
// with the License.  You may obtain a copy of the License at 
// 
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software 
// distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
//  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  
// See the License for the specific language governing permissions and 
// limitations under the License.
// 
// @author Thilina Gunarathne (tgunarat@indiana.edu)

#endregion

#region

using System;
using System.Web.UI;
using AzureMRCore.Client;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.StorageClient;

#endregion

namespace KMeansWebRole
{
    public partial class _Default : Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            if (JobNameTB.Text.Equals(""))
            {
                AlertLabel.Text = "You must provide a job name";
                return;
            }
            if (JobNameTB.Text.Equals(""))
            {
                AlertLabel.Text = "You must provide a blob for initial centroids";
                return;
            }
            CloudStorageAccount storageAccount = CloudStorageAccount.FromConfigurationSetting("DataConnectionString");
            CloudBlobClient blobClient = storageAccount.CreateCloudBlobClient();
            CloudBlobContainer container = blobClient.GetContainerReference(JobNameTB.Text + "out");
           
            container.CreateIfNotExist();
            var permissions = new BlobContainerPermissions {PublicAccess = BlobContainerPublicAccessType.Container};
            container.SetPermissions(permissions);

            var twisterAzureClient = new TwisterAzureClient(storageAccount, JobNameTB.Text, "mapshedq",
                                                                           "reduceshedq");
            twisterAzureClient.ProcessMapRed("KMeansMR", BlobContainerDD.Text, 0, "",
                                             Int32.Parse(NumReducersDD.SelectedItem.Value), JobNameTB.Text + "out",
                                             initCentroidsBox.Text, true);
            Response.Redirect(
                "/JobData.aspx?JobID=" + JobNameTB.Text + "&outcontainer=" + JobNameTB.Text + "out&refresh=10", true);
        }

        protected void initCentroidsBox_TextChanged(object sender, EventArgs e)
        {
        }
    }
}