#region LicenseHeader

// Copyright 2012 The Trustees of Indiana University.  All rights reserved.
// 
// The Indiana University licenses this file to you under the Apache License, 
// Version 2.0 (the "License"); you may not use this file except in compliance 
// with the License.  You may obtain a copy of the License at 
// 
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software 
// distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
//  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  
// See the License for the specific language governing permissions and 
// limitations under the License.
// 
// @author Thilina Gunarathne (tgunarat@indiana.edu)

#endregion

namespace NAligner.Formats
{
    /// <summary>
    ///   Abstract format
    /// </summary>
    public abstract class AlignmentFormatter
    {
        /// <summary>
        ///   Formatter id
        /// </summary>
        private string id;

        /// <summary>
        ///   Gets or sets format id
        /// </summary>
        public virtual string Id
        {
            get { return id == null ? GetType().FullName : id; }
            set { id = value; }
        }

        /// <summary>
        ///   Formats alignment
        /// </summary>
        /// <returns> formatted alignment </returns>
        public abstract string Format(PairwiseAlignment alignment);
    }
}