﻿#region LicenseHeader

// Copyright 2012 The Trustees of Indiana University.  All rights reserved.
// 
// The Indiana University licenses this file to you under the Apache License, 
// Version 2.0 (the "License"); you may not use this file except in compliance 
// with the License.  You may obtain a copy of the License at 
// 
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software 
// distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
//  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  
// See the License for the specific language governing permissions and 
// limitations under the License.
// 
// @author Thilina Gunarathne (tgunarat@indiana.edu)

#endregion

#region

using System.Collections.Generic;
using AzureMRCore;
using AzureMRCore.DataTypes;
using AzureMRCore.MapRed;

#endregion

namespace WordCountSample
{
    internal class WordCountMapper : Mapper<IntKey, StringValue, StringKey, IntValue, NullKey, NullValue>
    {
        protected override int Map(IntKey key, StringValue value, List<KeyValuePair<NullKey, NullValue>> dynamicData, IOutputCollector<StringKey, IntValue> outputCollector, string programArgs)
        {
            string line = value.GetTextValue();
            string[] words = line.Split(' ');
            foreach (string word in words)
            {
                outputCollector.Collect(StringKey.GetInstance(word), IntValue.GetInstance(1));
            }
            return 0;
        }
    }
}